<?php

/////////////////////////////////////// Localisation ///////////////////////////////////////


load_theme_textdomain('gp_lang', get_template_directory() . '/languages');
$locale = get_locale();
$locale_file = get_template_directory()."/languages/$locale.php";
if(is_readable($locale_file)) { require_once($locale_file); }


/////////////////////////////////////// Theme Information ///////////////////////////////////////


$themename = get_option('current_theme'); // Theme Name
$dirname = 'sell'; // Directory Name


/////////////////////////////////////// File Directories ///////////////////////////////////////


define('gp', get_template_directory() . '/');
define('gp_inc', get_template_directory() . '/lib/inc/');
define('gp_scripts', get_template_directory() . '/lib/scripts/');
define('gp_admin', get_template_directory() . '/lib/admin/inc/');
define('gp_wc', get_template_directory() . '/woocommerce/');


/////////////////////////////////////// Additional Functions ///////////////////////////////////////


// Image Resizer
require_once(gp_scripts . 'aq_resizer/aq_resizer.php');

// Main Theme Options
require_once(gp_admin . 'theme-options.php');
require(gp_inc . 'options.php');

// Meta Options
require_once(gp_admin . 'theme-meta-options.php');

// Sidebars
require_once(gp_admin . 'theme-sidebars.php');

// Woocommerce Functions
if(function_exists('is_woocommerce')) { require_once(gp_wc . 'functions-woocommerce.php'); }


/////////////////////////////////////// Enqueue Styles ///////////////////////////////////////


function gp_enqueue_styles() { 
	if(!is_admin()){
	
		require(gp_inc . 'options.php'); global $post, $dirname;

		wp_enqueue_style('gp-reset', get_template_directory_uri().'/lib/css/reset.css');

		wp_enqueue_style('gp-style', get_stylesheet_uri());

		wp_enqueue_style('gp-font-awesome', get_template_directory_uri().'/lib/fonts/font-awesome/css/font-awesome.min.css');

	 	wp_enqueue_style('gp-prettyphoto', get_template_directory_uri().'/lib/scripts/prettyPhoto/css/prettyPhoto.css');
		
		if(get_option($dirname.'_responsive') == "0") { wp_enqueue_style('gp-responsive', get_template_directory_uri().'/responsive.css'); }
		
		if(function_exists('is_woocommerce')) { wp_enqueue_style('gp-woocommerce-css', get_template_directory_uri().'/woocommerce/woocommerce.css'); }
		
		if(function_exists('is_woocommerce') && get_option($dirname.'_responsive') == "0") { wp_enqueue_style('gp-woocommerce-responsive-css', get_template_directory_uri().'/woocommerce/woocommerce-responsive.css'); }
		
		if(get_option($dirname.'_custom_stylesheet')) { wp_enqueue_style('gp-style-theme-custom', get_template_directory_uri().'/'.get_option($dirname.'_custom_stylesheet')); }
		
		if(is_singular() && get_post_meta($post->ID, '_'.$dirname.'_custom_stylesheet', true)) { wp_enqueue_style('gp-style-page-custom', get_template_directory_uri().'/'.get_post_meta($post->ID, '_'.$dirname.'_custom_stylesheet', true)); }
	
	}
}
add_action('wp_enqueue_scripts', 'gp_enqueue_styles');


/////////////////////////////////////// Enqueue Scripts ///////////////////////////////////////


function gp_enqueue_scripts() { 
	if(!is_admin()){
	
		require(gp_inc . 'options.php');

		wp_enqueue_script('gp-modernizr', get_template_directory_uri().'/lib/scripts/modernizr.js', '', '', false);
						
		if(is_singular() && comments_open() && get_option('thread_comments')) { wp_enqueue_script('comment-reply'); }

		wp_register_script('gp-touchswipe', get_template_directory_uri().'/lib/scripts/jquery.touchSwipe.min.js', array('jquery'), '', true);
		
		wp_register_script('gp-infinitescroll', get_template_directory_uri().'/lib/scripts/jquery.infinitescroll.min.js', array('jquery'), '', true);

		wp_register_script('gp-superslides', get_template_directory_uri().'/lib/scripts/jquery.superslides.js', array('jquery'), '', true);

		wp_register_script('gp-easing', get_template_directory_uri().'/lib/scripts/jquery.easing.1.3.js', array('jquery'), '', true);
			
		wp_register_script('gp-animate-enhanced', get_template_directory_uri().'/lib/scripts/jquery.animate-enhanced.min.js', array('jquery'), '', true);
						
		wp_enqueue_script('gp-jqtransform', get_template_directory_uri().'/lib/scripts/jquery.jqtransform.js', array('jquery'), '', true);					

		wp_register_script('gp-addthis', '//s7.addthis.com/js/300/addthis_widget.js#pubid=xa-51e55a5b6c5a9eac', '', '', true);

		wp_enqueue_script('gp-prettyphoto', get_template_directory_uri().'/lib/scripts/prettyPhoto/js/jquery.prettyPhoto.js', array('jquery'), '', true);

		wp_enqueue_script('gp-prettyphoto-init', get_template_directory_uri().'/lib/scripts/prettyPhoto/js/jquery.prettyPhoto-init.js', array('gp-prettyphoto'), '', true);

		if(function_exists('is_woocommerce')) { wp_enqueue_script('gp-woocommerce-js', get_template_directory_uri().'/woocommerce/woocommerce.js', array('jquery'), '', true); }
										
		wp_enqueue_script('gp-custom-js', get_template_directory_uri().'/lib/scripts/custom.js', array('jquery'), '', true);
							
	}
}
add_action('wp_enqueue_scripts', 'gp_enqueue_scripts');


/////////////////////////////////////// WP Header Hooks ///////////////////////////////////////


function gp_wp_header() {
	
	require(gp_inc . 'options.php'); global $dirname;
	
    if(get_option($dirname.'_favicon_ico')) { echo '<link rel="shortcut icon" href="'.get_option($dirname.'_favicon_ico').'" /><link rel="icon" href="'.get_option($dirname.'_favicon_ico').'" type="image/vnd.microsoft.icon" />'; }
    
    if(get_option($dirname.'_favicon_png')) { echo '<link rel="icon" type="image/png" href="'.get_option($dirname.'_favicon_png').'" />'; }
    
    if(get_option($dirname.'_apple_icon')) { echo '<link rel="apple-touch-icon" href="'.get_option($dirname.'_apple_icon').'" />'; }

	require_once(gp_inc . 'style-settings.php');

	echo '<script>var navigationText = "'.__('Navigation', 'gp_lang').'"; var emptySearchText = "'.__('Please enter something in the search box!', 'gp_lang').'";';
	
	if(get_option($dirname."_retina") == "0") {
		echo 'jQuery(document).ready(function(){window.devicePixelRatio>=2&&jQuery(".post-thumbnail img").each(function(){jQuery(this).attr({src:jQuery(this).attr("data-rel")})})});';
	}
	
	echo '</script>';
	
	if(get_option($dirname.'_scripts')) { echo stripslashes(get_option($dirname.'_scripts')); }
	
}
add_action('wp_head', 'gp_wp_header');


/////////////////////////////////////// Navigation Menus ///////////////////////////////////////


add_action('init', 'gp_register_menus');
function gp_register_menus() {
	register_nav_menus(array(
		'left-header-nav' => __('Left Header Navigation', 'gp_lang'),
		'right-header-nav' => __('Right Header Navigation', 'gp_lang')
	));
}

/*************************************** Mobile Navigation Walker ***************************************/	

class gp_mobile_menu extends Walker_Nav_Menu {

	var $to_depth = -1;

    function start_lvl(&$output, $depth){
		$output .= '</option>';
    }

    function end_lvl(&$output, $depth){
		$indent = str_repeat("\t", $depth); // don't output children closing tag
    }

    function start_el(&$output, $item, $depth, $args){
		$indent = ($depth) ? str_repeat("- ", $depth) : '';
		$class_names = $value = '';
		$classes = empty($item->classes) ? array() : (array) $item->classes;
		$classes[] = 'mobile-menu-item-' . $item->ID;
		$class_names = join(' ', apply_filters('nav_menu_css_class', array_filter($classes), $item, $args));
		$class_names = ' class="' . esc_attr($class_names) . '"';
		$id = apply_filters('nav_menu_item_id', 'mobile-menu-item-'. $item->ID, $item, $args);
		$id = strlen($id) ? ' id="' . esc_attr($id) . '"' : '';
		$value = ' value="'. $item->url .'"';
		$output .= '<option'.$id.$value.$class_names.'>';
		$item_output = $args->before;
		$item_output .= $args->link_before . apply_filters('the_title', $item->title, $item->ID) . $args->link_after;
		$output .= $indent.$item_output;
    }

    function end_el(&$output, $item, $depth){
		if(substr($output, -9) != '</option>')
      		$output .= "</option>"; // replace closing </li> with the option tag
    }

}


/////////////////////////////////////// Theme Support ///////////////////////////////////////


// Featured images
add_theme_support('post-thumbnails');
set_post_thumbnail_size(150, 150, true);

// Background customizer
add_theme_support('custom-background');

// This theme styles the visual editor with editor-style.css to match the theme style.
add_editor_style();

// Set the content width based on the theme's design and stylesheet.
if(!isset($content_width)) { $content_width = 870; }

// Add default posts and comments RSS feed links to <head>.
add_theme_support('automatic-feed-links');

// WooCommerce Support
add_action('after_setup_theme', 'gp_woocommerce_support');
function gp_woocommerce_support() {
	add_theme_support('woocommerce');
}

		
/////////////////////////////////////// Excerpts ///////////////////////////////////////


// Character Length
function gp_excerpt_length($length) {
	return 10000;
}
add_filter('excerpt_length', 'gp_excerpt_length');

function excerpt($count, $ellipsis = '...') {
	$excerpt = get_the_excerpt();
	$excerpt = strip_tags($excerpt);
	if(function_exists('mb_strlen') && function_exists('mb_substr')) { 
		if(mb_strlen($excerpt) > $count) {
			$excerpt = mb_substr($excerpt, 0, $count).$ellipsis;
		}
	} else {
		if(strlen($excerpt) > $count) {
			$excerpt = substr($excerpt, 0, $count).$ellipsis;
		}	
	}
	return $excerpt;
}

// Replace Excerpt Ellipsis
function gp_excerpt_more($more) {
	return '';
}
add_filter('excerpt_more', 'gp_excerpt_more');

// Content More Text
function gp_more_link($more_link, $more_link_text) {
	return str_replace('more-link', 'button more-link read-more', $more_link);
}
add_filter('the_content_more_link', 'gp_more_link', 10, 2);


/////////////////////////////////////// Add Excerpt Support To Pages ///////////////////////////////////////


add_action('init', 'gp_add_excerpts_to_pages');
function gp_add_excerpts_to_pages() {
     add_post_type_support('page', 'excerpt');
}


/////////////////////////////////////// Title Length ///////////////////////////////////////


function gp_the_title_limit($count, $ellipsis = '...') {
	$title = the_title_attribute( 'echo=0' );
	$title = strip_tags($title);
	if(function_exists('mb_strlen') && function_exists('mb_substr')) { 
		if(mb_strlen($title) > $count) {
			$title = mb_substr($title, 0, $count).$ellipsis;
		}
	} else {
		if(strlen($title) > $count) {
			$title = substr($title, 0, $count).$ellipsis;
		}	
	}
	return $title;
}


/////////////////////////////////////// Page Navigation ///////////////////////////////////////

/*function gp_pagination() {

	global $wp_query, $wp_rewrite, $gp_settings;
	
	$wp_query->query_vars['paged'] > 1 ? $current = $wp_query->query_vars['paged'] : $current = 1;
	
	$pagination = array(
		'base' => @add_query_arg('page','%#%'),
		'format' => '/page/%#%',
		'total' => $wp_query->max_num_pages,
		'current' => $current,
		'show_all' => true,
		'type' => 'list',
		'next_text' => '&raquo;',
		'prev_text' => '&laquo;'
	);
	
	if($wp_rewrite->using_permalinks()) {
		$pagination['base'] = user_trailingslashit(trailingslashit(remove_query_arg('s', get_pagenum_link(1))) . 'page/%#%/', 'paged');
	}
	
	if(!empty($wp_query->query_vars['s'])) {
		$pagination['add_args'] = array('s' => get_query_var('s'));
	}

	if($gp_settings['infinite_scrolling'] == "0") {
		echo '<div class="hide-pagination">'.paginate_links($pagination).'</div>';
	} else {
		echo paginate_links($pagination);
	}
		
}
*/


function gp_pagination($pages = '', $range = 2)
{  
     $showitems = ($range * 2)+1;  

     global $paged, $gp_settings;
     
	 if (get_query_var('paged')) {
		 $paged = get_query_var('paged');
	 } elseif (get_query_var('page')) {
		 $paged = get_query_var('page');
	 } else {
		 $paged = 1;
	 }

     if($pages == '')
     {
         global $wp_query;
         $pages = $wp_query->max_num_pages;
         if(!$pages)
         {
             $pages = 1;
         }
     }   
	
     if(1 != $pages) {
     
		if($gp_settings['infinite_scrolling'] == "0") { echo '<div class="hide-pagination">'; }

		echo '<ul class="page-numbers">';

		if($paged > 2 && $paged > $range+1 && $showitems < $pages) echo '<li><a href="'.get_pagenum_link(1).'" class="page-numbers">&laquo;</a></li>';
		
		if($paged > 1 && $showitems < $pages) echo '<li><a href="'.get_pagenum_link($paged - 1).'" class="page-numbers">&lsaquo;</a></li>';

		for ($i=1; $i <= $pages; $i++) {
			if (1 != $pages &&(!($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems)) {
				echo ($paged == $i) ? '<li><span class="page-numbers current">'.$i.'</span></li>' : '<li><a href="'.get_pagenum_link($i).'" class="page-numbers" >'.$i.'</a></li>';
			}
		}

		if ($paged < $pages && $showitems < $pages) echo '<li><a href="'.get_pagenum_link($paged + 1).'" class="page-numbers">&rsaquo;</a></li>'; 
		 
		if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages) echo '<li><a href="'.get_pagenum_link($pages).'" class="page-numbers">&raquo;</a></li>';
		echo "</ul>";

		if($gp_settings['infinite_scrolling'] == "0") { echo '</div>'; }	

	}

}


/////////////////////////////////////// Shortcode Support For Text Widget ///////////////////////////////////////


add_filter('widget_text', 'do_shortcode');


/////////////////////////////////////// Shortcode Empty Paragraph Fix ///////////////////////////////////////


add_filter('the_content', 'gp_shortcode_empty_paragraph_fix');
function gp_shortcode_empty_paragraph_fix($content)
{   
	$array = array (
		'<p>[' => '[', 
		']</p>' => ']',
		']<br />' => ']'
	);
	$content = strtr($content, $array);
	return $content;
}


/////////////////////////////////////// Change Insert Into Post Text ///////////////////////////////////////	


if(is_admin() && $pagenow == "themes.php") {
	add_filter('gettext', 'gp_change_image_button', 10, 3);
	function gp_change_image_button($translation, $text, $domain) {
		if('default' == $domain and 'Insert into post' == $text) {
			remove_filter('gettext', 'gp_change_image_button');
			return __('Use Image', 'gp_lang');
		}
		return $translation;
	}
}


/////////////////////////////////////// WPML Language Selector ///////////////////////////////////////


function gp_languages_list_footer() {
    $languages = icl_get_languages('skip_missing=0&orderby=id&order=asc');
    if(!empty($languages)) {
        echo '<div id="footer-language-list"><ul>';
        foreach($languages as $l) {
            echo '<li>';
            if($l['country_flag_url']) {
                if(!$l['active']) echo '<a href="'.$l['url'].'">';
                echo '<img src="'.$l['country_flag_url'].'" height="12" alt="'.$l['language_code'].'" width="18" />';
                if(!$l['active']) echo '</a>';
            }
            if(!$l['active']) { echo '<a href="'.$l['url'].'">'; }
            echo icl_disp_language($l['native_name'], $l['translated_name']);
            if(!$l['active']) { echo '</a>'; }
            echo '</li>';
        }
        echo '</ul></div>';
    }
}


/////////////////////////////////////// TMG Plugin Activation ///////////////////////////////////////	


require_once(gp_admin . 'class-tgm-plugin-activation.php');

add_action('tgmpa_register', 'gp_register_required_plugins');

function gp_register_required_plugins() {

	$plugins = array(

		array(
			'name' => 'Sell Plugin',
			'slug' => 'sell-plugin',
			'source' => get_stylesheet_directory() . '/lib/plugins/sell-plugin.zip',
			'force_activation' => true,
			'force_deactivation' => true,
			'version' => '1.3.3'
		),

		array(
			'name'               => 'WPBakery Visual Composer',
			'slug'               => 'js_composer',
			'source'             => get_stylesheet_directory() . '/lib/plugins/js_composer.zip',
			'required'           => false,
			'version'            => '4.0.2',
			'force_activation'	 => false,
			'force_deactivation' => false,
		),
			
		array(
			'name' => 'UberMenu 2 - WordPress Mega Menu Plugin',
			'slug' => 'ubermenu',
			'source' => 'none',
			'required' => false,
			'external_url' => 'http://codecanyon.net/item/ubermenu-wordpress-mega-menu-plugin/154703?ref=GhostPool',
		),

		array(
			'name' => 'Contact Form 7',
			'slug' => 'contact-form-7',
			'required' 	=> false,
		),
		
		array(
			'name' => 'WooCommerce',
			'slug' => 'woocommerce',
			'required' 	=> false,
		),
				
		array(
			'name' => 'WooCommerce Predictive Search Pro',
			'slug' => 'woocommerce-products-predictive-search-pro',
			'source' => get_stylesheet_directory() . '/lib/plugins/woocommerce-products-predictive-search-pro.zip',
			'required' => false,
			'force_activation' => false,
			'force_deactivation' => false,
			'version' => '2.2.2.1'
		),
		
	);

	$config = array(
		'default_path' => '', // Default absolute path to pre-packaged plugins
		'parent_menu_slug' => 'themes.php', // Default parent menu slug
		'parent_url_slug' => 'themes.php', // Default parent URL slug
		'menu' => 'install-required-plugins', // Menu slug
		'has_notices' => true, // Show admin notices or not
		'is_automatic' => true, // Automatically activate plugins after installation or not
		'message' => '', // Message to output right before the plugins table
	);

	tgmpa($plugins, $config);

}

if ( function_exists( 'vc_set_as_theme' ) ) { vc_set_as_theme(); }

?>