<?php require(gp_inc . 'options.php'); global $dirname, $gp_settings;


// Post Query

$tags = wp_get_post_tags(get_the_ID());
$tempQuery = $wp_query;

if($tags) {

	$tag_ids = array();

	foreach($tags as $individual_tag) $tag_ids[] = $individual_tag->term_id;

	$args=array(
		'post_type' => 'post',
		'ignore_sticky_posts' => 0,
		'orderby' => 'rand',
		'order' => 'asc',
		'paged' => 1,
		'posts_per_page' => $gp_settings['related_per_page'],
		'offset' => 0,
		'tag__in' => $tag_ids,
		'post__not_in' => array(get_the_ID())
	); 

	$featured_query = new wp_query($args);


	// Column Width

	$col_width = (100 - (($gp_settings['related_per_page']*2) - 2)) / $gp_settings['related_per_page'];
		
	?>

	
	<div class="related-posts">


		<!-- BEGIN HEADER -->

		<header class="related-posts-title">
		
			<h3><?php echo _e('Related Posts', 'gp_lang'); ?></h3>

		</header>
		
		<!-- END HEADER -->
	

		<?php while ($featured_query->have_posts()) : $featured_query->the_post(); ?>

			
			<!-- BEGIN POST -->
		
			<article <?php post_class('post-loop'); ?> style="width: <?php echo $col_width; ?>%;">
				
					
				<!-- BEGIN FEATURED IMAGE -->
	
				<?php if(has_post_thumbnail()) { ?>					
					<div class="post-thumbnail">
						<a href="<?php the_permalink(); ?>">					
							<?php $image = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $gp_settings['related_image_width'], $gp_settings['related_image_height'], $gp_settings['hard_crop'], false, true); ?>
							<?php if(get_option($dirname."_retina") == "0") { $retina = aq_resize(wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())), $gp_settings['related_image_width']*2, $gp_settings['related_image_height']*2, $gp_settings['hard_crop'], false, true); } else { $retina = ""; } ?>
							<img src="<?php echo $image[0]; ?>" data-rel="<?php echo $retina[0]; ?>" width="<?php echo $image[1]; ?>" height="<?php echo $image[2]; ?>" alt="<?php if(get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true)) { echo get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true); } else { the_title_attribute(); } ?>" class="wp-post-image" />		
						</a>			
					</div>	
				<?php } ?>
	
				<!-- END FEATURED IMAGE -->

			
				<!-- BEGIN POST TEXT -->
			
				<div class="post-text">
			
			
					<!-- BEGIN TITLE -->
				
					<h2><a href="<?php the_permalink(); ?>" title="<?php the_title_attribute(); ?>"><?php the_title(); ?></a></h2>
				
					<!-- END TITLE -->

			
					<!-- BEGIN ENTRY META-->
							
					<div class="entry-meta">
							
						<span class="meta-date"><?php the_time(get_option('date_format')); ?></span>
				
					</div>
			
					<!-- END ENTRY META-->
				
		
				</div>
			
				<!-- END POST TEXT -->
			

			</article>
		
			<!-- END POST -->
		
		
		<?php endwhile; ?>

	
	</div>
	

<?php } wp_reset_query(); ?>