<?php


/////////////////////////////////////// Theme Defaults ///////////////////////////////////////	


// WooCommerce Defaults

if(is_admin() && isset($_GET['activated']) && $pagenow == "themes.php") {

	global $dirname;

	if(get_option($dirname.'_theme_auto_install') !== '1') {
	
		add_action('init', 'gp_woocommerce_defaults', 1);		
		function gp_woocommerce_defaults() {		
			update_option('shop_catalog_image_size', array('width' => 211, 'height' => 280, 'crop' => 1));
			update_option('shop_thumbnail_image_size', array('width' => 60, 'height' => 60, 'crop' => 1)); 
			update_option('shop_single_image_size', array('width' => 500, 'height' => 700, 'crop' => 1));
			update_option('woocommerce_magnifier_image', array('width' => 1000, 'height' => 1400, 'crop' => 1)); 
			update_option('woocommerce_frontend_css', 1);
			update_option('woocommerce_enable_lightbox', 1);			
			update_option('yith_wcmg_zoom_position', 'right');
			update_option('yith_wcmg_zoom_mobile_position', 'inside');
			update_option('yith_wcmg_enableslider', 1);
		}						
	
		update_option($dirname.'_theme_auto_install', '1');			

	}
		
}
	

// Activate WooCommerce Predicitive Search

if(is_admin()) {
	add_action('init', 'gp_predictive_activation', 1);		
	function gp_predictive_activation() {		
		if(get_option('a3rev_auth_woo_predictive_search') != '21f7ecc89397dec2d7de160975b96e74') {
			update_option('a3rev_pin_woo_predictive_search', sha1(md5('a3rev.com_'.get_option('siteurl').'_woo_predictive_search')));
			update_option('a3rev_auth_woo_predictive_search', '21f7ecc89397dec2d7de160975b96e74');
			delete_transient("woo_predictive_search_update_info");
			update_option('a3rev_woo_predictivesearch_just_confirm', 0);	
		}
	}	
}

remove_action('after_plugin_row_woocommerce-products-predictive-search-pro/wc-predictive-search.php', array('WC_Predictive_Search_Upgrade', 'plugin_row_alert_new_version'));


/////////////////////////////////////// Disable Default WC Stylesheet ///////////////////////////////////////


if ( version_compare( WOOCOMMERCE_VERSION, "2.1" ) >= 0 ) {
	add_filter( 'woocommerce_enqueue_styles', '__return_false' );
} else {
	define( 'WOOCOMMERCE_USE_CSS', false );
}

			
/////////////////////////////////////// Remove Default Product Page Hooks ///////////////////////////////////////

			 
remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_title', 5);
remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_price', 10);
remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_excerpt', 20);
remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30);
remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_meta', 40);
remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_sharing', 50);
			
			
/////////////////////////////////////// Related Products Per Page ///////////////////////////////////////


function woocommerce_output_related_products() {
	global $gp_settings;
	woocommerce_related_products($gp_settings['related_per_page'], 1);
}


/////////////////////////////////////// Remove Tabs ///////////////////////////////////////


add_filter('woocommerce_product_tabs', 'gp_remove_product_tabs', 98);
function gp_remove_product_tabs($tabs) {
    unset($tabs['description']);      
    unset($tabs['reviews']);
    unset($tabs['additional_information']);
    return $tabs;
}


/////////////////////////////////////// Remove Sales Badge ///////////////////////////////////////


/*add_filter('woocommerce_sale_flash', 'gp_hide_sales_flash');
function gp_hide_sales_flash() {
	return false;
}*/


/////////////////////////////////////// Replace Pagination ///////////////////////////////////////


if(!is_admin()) { 	
	remove_action('woocommerce_pagination', 'woocommerce_pagination', 10);
	function woocommerce_pagination() {
		gp_pagination();
	}
	add_action('woocommerce_pagination', 'woocommerce_pagination', 10);
}


/////////////////////////////////////// Product Category Images (Catalog) ///////////////////////////////////////


remove_action('woocommerce_before_shop_loop_item_title', 'woocommerce_template_loop_product_thumbnail', 10);
add_action('woocommerce_before_shop_loop_item_title', 'woocommerce_template_loop_product_thumbnail', 10);
 
if(!function_exists('woocommerce_template_loop_product_thumbnail')) {
	function woocommerce_template_loop_product_thumbnail() {
		echo woocommerce_get_product_thumbnail();
	} 
}
 
if(!function_exists('woocommerce_get_product_thumbnail')) {
	
	function woocommerce_get_product_thumbnail($size = 'shop_catalog', $placeholder_width = 0, $placeholder_height = 0) {
	
		global $post, $product, $woocommerce, $dirname;
 
		if(!$placeholder_width) {
			$placeholder_width = get_option('shop_catalog_image_size');
			$placeholder_width = $placeholder_width['width'];
		}
		if(!$placeholder_height) {
			$placeholder_height = get_option('shop_catalog_image_size');
			$placeholder_height = $placeholder_height['height'];
		}
		$placeholder_crop = get_option('shop_catalog_image_size');
		$placeholder_crop = $placeholder_crop['crop'];
		
		
		$output = "";
		
		$output .= '<span class="product-image-container">';
			
		if(has_post_thumbnail()){

			$attachment_ids = $product->get_gallery_attachment_ids();				
			if($attachment_ids) {
				foreach($attachment_ids as $attachment_id){
					if($attachment_id != get_post_thumbnail_id()) {
						$image = aq_resize(wp_get_attachment_url($attachment_id), $placeholder_width, $placeholder_height, $placeholder_crop, false, true);					
						if(get_option($dirname."_retina") == "0") { $retina = aq_resize(wp_get_attachment_url($attachment_id), $placeholder_width*2, $placeholder_height*2, $placeholder_crop, false, true); } else { $retina = ""; }	
					}
				}
			
				$output .= '<img src="'.$image[0].'" data-rel="'.$retina[0].'" width="'.$image[1].'" height="'.$image[2].'" alt="'.get_the_title($attachment_id).'" class="wp-post-image image-overlay" />';

			}

			$image = aq_resize(wp_get_attachment_url(get_post_thumbnail_id($post->ID)), $placeholder_width, $placeholder_height, $placeholder_crop, false, true);		
			if(get_option($dirname."_retina") == "0") { $retina = aq_resize(wp_get_attachment_url(get_post_thumbnail_id($post->ID)), $placeholder_width*2, $placeholder_height*2, $placeholder_crop, false, true); } else { $retina = ""; }
		
			$output .= '<img src="'.$image[0].'" data-rel="'.$retina[0].'" width="'.$image[1].'" height="'.$image[2].'" alt="'.get_the_title(get_post_thumbnail_id()).'" class="attachment-shop_catalog wp-post-image" />';			
			
		} else {
		
			$output .= '<img src="'.woocommerce_placeholder_img_src().'" alt="'.__('Placeholder' , 'gp_lang').'" width="'.$placeholder_width.'" height="'.$placeholder_height.'" />';

		}
		
		$output .= '</span>';
		
		return $output;
	}
 }
 

/////////////////////////////////////// Dropdown Cart ///////////////////////////////////////


/////// Plugin Check ///////


function gp_dropdown_plugin_installed() {
    
	if(function_exists('dropdowncart_scripts')) { ?>
	
		<div class="error"><p><?php _e('Woocommerce Dropdown Cart Widget is already built into this theme, please deactivate this plugin.', 'gp_lang'); ?></p></div>
		
	<?php }
}
add_action('admin_notices', 'gp_dropdown_plugin_installed');


/////// Dropdown Cart Loop ///////


function gp_dropdown_loop() {
	
	global $woocommerce;

	if(sizeof($woocommerce->cart->cart_contents) > 0) {
	
		$i = 0;				
		
		foreach ($woocommerce->cart->cart_contents as $cart_item_key => $cart_item) {
	
			$i++;
			
			if ($i == 1) {				
				$rowclass = ' class="cart-oddrow"';			
			} else {
				$rowclass = ' class="cart-evenrow"';
				$i = 0;
			}

			$_product = $cart_item['data'];
	
			if ($_product->exists() && $cart_item['quantity'] > 0) {
		
				echo '<li'.$rowclass.'>';
		
				echo '<div class="dropdowncart-image">';
				echo '<a href="'.get_permalink($cart_item['product_id']).'">';				
				
				if (has_post_thumbnail($cart_item['product_id'])) {					
					echo get_the_post_thumbnail($cart_item['product_id'], 'shop_thumbnail'); 
				} else {					 
					echo '<img src="'.$woocommerce->plugin_url().'/assets/images/placeholder.png" alt="Placeholder" width="'.$woocommerce->get_image_size('shop_thumbnail_image_width').'" height="'.$woocommerce->get_image_size('shop_thumbnail_image_height').'" />'; 				
				}
								
				echo '</a>';
				echo '</div>';
		
				echo '<div class="dropdowncart-product">';
			
					echo '<a href="'.get_permalink($cart_item['product_id']).'">';				
					echo apply_filters('woocommerce_cart_widget_product_title', $_product->get_title(), $_product).'</a>';				
					if ($_product instanceof woocommerce_product_variation && is_array($cart_item['variation'])) {
						echo woocommerce_get_formatted_variation($cart_item['variation']);
					}
					echo '</a>';
			
					echo '<span class="quantity">' .$cart_item['quantity'].' &times; '.woocommerce_price($_product->get_price()).'</span>';

				echo '</div>';
		
				echo '</li>';
			
			}
			
		}
		
	} else {
	 
		echo '<li class="empty">'.__('No products in the cart.', 'gp_lang').'</li>'; 
	
	} ?>
					
	<?php if(sizeof($woocommerce->cart->cart_contents) > 0) {
	
		echo '<li class="total"><strong>';
		
		if(get_option('js_prices_include_tax') == 'yes') {
			_e('Total', 'gp_lang');
		} else {
			_e('Subtotal', 'gp_lang');
		}

		echo ':</strong> '.$woocommerce->cart->get_cart_total();
		
		echo '</li>';
		
		do_action('woocommerce_widget_shopping_cart_before_buttons');
		
		echo '<li class="dropdowncart-buttons">
				  <a href="'.$woocommerce->cart->get_cart_url().'" class="button">'.__('View Cart', 'gp_lang').'</a> <a href="'.$woocommerce->cart->get_checkout_url().'" class="button">'.__('Checkout', 'gp_lang').'</a>
			  </li>';
	}
			
}


/////// Normal Dropdown Cart ///////

														
function gp_dropdown_cart() {

	global $woocommerce;

	if(is_cart()) return; ?>
	
	<ul class="dropdowncart menu">
	
		<li><a href="<?php echo $woocommerce->cart->get_cart_url(); ?>" class="mobile-icon cart-button" title="<?php _e('View your shopping cart', 'gp_lang'); ?>">
			<i class="fa fa-shopping-cart"></i> 
			<span class="mobile-basket-info"><?php _e('Basket', 'gp_lang'); ?> (<?php echo sprintf(_n('%d', '%d', $woocommerce->cart->cart_contents_count, 'gp_lang'), $woocommerce->cart->cart_contents_count);?>)</span>	
			<span class="computer-basket-info"><?php echo $woocommerce->cart->get_cart_total(); ?> (<?php echo sprintf(_n('%d', '%d', $woocommerce->cart->cart_contents_count, 'gp_lang'), $woocommerce->cart->cart_contents_count);?>)</span>
		</a>
		
	
			<ul class="sub-menu">
				<?php echo gp_dropdown_loop(); ?>			
			</ul>
		
		</li>
		
	</ul>
	
<?php }


/////// Ajaxify Cart Details ///////


add_filter('add_to_cart_fragments', 'gp_woocommerce_header_add_to_cart_fragment');

function gp_woocommerce_header_add_to_cart_fragment($fragments) {
	
	global $woocommerce; ob_start(); ?>
	
			<a href="<?php echo $woocommerce->cart->get_cart_url(); ?>" class="mobile-icon cart-button" title="<?php _e('View your shopping cart', 'gp_lang'); ?>">
				<i class="fa fa-shopping-cart"></i>
				<span class="mobile-basket-info"><?php _e('Basket', 'gp_lang'); ?> (<?php echo sprintf(_n('%d', '%d', $woocommerce->cart->cart_contents_count, 'gp_lang'), $woocommerce->cart->cart_contents_count);?>)</span>			
				<span class="computer-basket-info"><?php echo $woocommerce->cart->get_cart_total(); ?> (<?php echo sprintf(_n('%d', '%d', $woocommerce->cart->cart_contents_count, 'gp_lang'), $woocommerce->cart->cart_contents_count);?>)</span>
			</a>
	
	<?php $fragments['a.cart-button'] = ob_get_clean();

	return $fragments;

}


/////// Ajaxify Dropdwon Cart ///////


add_filter('add_to_cart_fragments', 'gp_woocommerce_header_dropdown_fragment');

function gp_woocommerce_header_dropdown_fragment($fragments) {
	
	global $woocommerce; ob_start(); ?>
		
		<ul class="sub-menu">
			<?php echo gp_dropdown_loop(); ?>			
		</ul>

	<?php $fragments['.dropdowncart .sub-menu'] = ob_get_clean();

	return $fragments;

}


?>